package indi.felix.easy.core.elastic.utool;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.elasticsearch.action.index.IndexRequest;
import org.elasticsearch.common.xcontent.XContentType;

import java.util.Map;

public class EsUtils {

    public static IndexRequest setDefaultProperties(IndexRequest indexRequest, Object object, String idKey, String routingKey, String parentKey) {
        JSONObject jsonObject = null;
        if (object instanceof JSONObject) {
            jsonObject = (JSONObject) object;
        } else if (object instanceof String) {
            jsonObject = JSON.parseObject(object.toString());
        } else {
            jsonObject = (JSONObject) JSONObject.toJSON(object);
        }

        if (StringUtils.isNotBlank(idKey)) {
            String id = jsonObject.getString(idKey);
            if (StringUtils.isNotBlank(id)) {
                indexRequest.id(id);
                // 删除id字段
                jsonObject.remove(idKey);
            }
        }

        if (StringUtils.isNotBlank(routingKey)) {
            String routing = jsonObject.getString(routingKey);
            if (StringUtils.isNotBlank(routing)) {
                indexRequest.routing(routing);
                // 删除routing字段
                jsonObject.remove(routingKey);
            }
        }

        if (StringUtils.isNotBlank(parentKey)) {
            String parent = jsonObject.getString(parentKey);
            if (StringUtils.isNotBlank(parent)) {
                indexRequest.parent(parent);
                // 删除parentkey字段
                jsonObject.remove(parentKey);
            }
        }

//        if (jsonObject.containsKey(Const.ID)) {
//            String id = jsonObject.getString(Const.ID);
//            if (StringUtils.isNotBlank(id)) {
//                indexRequest.id(id);
//            }
//        } else if (jsonObject.containsKey("ID")) {
//            String id = jsonObject.getString("ID");
//            if (StringUtils.isNotBlank(id)) {
//                indexRequest.id(id);
//            }
//        }
//
//        if (jsonObject.containsKey(Const.ROUTING)) {
//            String routing = jsonObject.getString(Const.ROUTING);
//            if (StringUtils.isNotBlank(routing)) {
//                indexRequest.routing(routing);
//            }
//        }
//
//        if (jsonObject.containsKey(Const.PARENT)) {
//            String parent = jsonObject.getString(Const.PARENT);
//            if (StringUtils.isNotBlank(parent)) {
//                indexRequest.parent(parent);
//            }
//        }

        if (jsonObject != null){
            indexRequest.create(false).source(JSON.toJSONString(jsonObject), XContentType.JSON);
        }

        return indexRequest;
    }
}
